
setMethod("getWellId",
          signature(aFlowFrame = "flowFrame"), 
          definition = function(aFlowFrame) {

  wellInfo <- list(RowSymbol="NA", Column="NA");
  # First try this
  wellId   <- as.character(keyword(aFlowFrame, 'WELL ID'));
  # Then try this
  if (wellId == "NULL") { 
    wellId <- as.character(keyword(aFlowFrame, 'TUBE NAME')); 
  }
  # Gasp, try looking at the file name
  if (wellId == "NULL") {
    wellId <- gsub(".*([A-P]\\d+).*", "\\1", keyword(aFlowFrame, '$FIL'), 
                   ignore.case=TRUE, perl=TRUE);
    if (length(wellId) == 0) { wellId = "NULL"; }
    if (length(grep("[A-P]\\d+", wellId, perl=TRUE, ignore.case=TRUE)) == 0) wellId = "NULL";
  }
  
  # Last ditch effort...
  if (wellId == "NULL") {
    wellId <- gsub(".*([A-P]\\d+).*", "\\1", identifier(aFlowFrame), 
                   ignore.case=TRUE, perl=TRUE);
    if (length(wellId) == 0) { wellId = "NULL"; }
    if (length(grep("[A-P]\\d+", wellId, perl=TRUE, ignore.case=TRUE)) == 0) wellId = "NULL";
  }
  
  
  if (wellId == "NULL") { 
    return(wellInfo); 
  } else {  
    wellInfo$RowSymbol = toupper(substr(wellId, 1,1));
    wellInfo$Column    = as.numeric(substr(wellId, 2, nchar(wellId)));    
  }
  return(wellInfo);
});
  

